DECLARE SUB LCOPY (SCR!, DENS!)
DECLARE SUB ModGraf (Scheda!)

CLS
PRINT "                  TELMAT - vers. 1.4                 rev. 02.94"
PRINT : PRINT
PRINT "        Le ipotesi  di calcolo  e le  modalit  operative  del  programma"
PRINT "        TELMAT sono riportate nella terza parte,  capitolo 5,  del libro:"
PRINT "        A.Ghersi, Edifici antisismici con struttura intelaiate in cemento"
PRINT "        armato, CUEN, Napoli, 1988."
PRINT
PRINT "        In aggiunta a quanto indicato nel libro, la versione 1.4 consente"
PRINT "        di mandare in esecuzione  il programma  con le seguenti opzioni:"
PRINT "           /SI    se dati e risultati sono nel sistema internazionale"
PRINT "           /C     per far stampare i dati  man mano che vengono letti"
PRINT "           /D     per tener conto della deformabilit tagliante XT/GA"
PRINT "           /R     per calcolare la rigidezza del telaio"
PRINT "        Per altre informazioni sulla versione 1.4, leggere il file  HELP."
PRINT : PRINT
'
C$ = COMMAND$
IF INSTR(C$, "/SI") = 0 THEN STecn = 1 ELSE STecn = 0
Contr = INSTR(C$, "/C")
DefTag = INSTR(C$, "/D")
IF INSTR(C$, "/R") = 0 THEN CalcRig = 0 ELSE CalcRig = 1
IF STecn THEN SqAm = .001 ELSE SqAm = .01

10  OPTION BASE 1 '   definisce l'estremo inferiore dell'indice degli array
20  MI = 300: MJ = 500: MK = 12: ML = 50: MN = 600
30  DIM V(3), N(6), LD(6, 6), LDT(6, 6), T(6, 3), KF(3, 3), KG(6, 6)
40  DIM ATX(6, 3), AT(6, 3), A(3, 6), S(6), SX(6), SS(6), SSX(6), S1(6)
50  DIM X(MI), Y(MI), V$(MI), NI(MI + MK), G(MI, 3), KV(MI, 3)
60  DIM ZB(ML), ZH(ML), ZA(ML), ZI(ML)
70  DIM E1(MJ), E2(MJ), NT(MJ), SA(MJ), SI(MJ)
80  DIM M1(MJ), M2(MJ), T1(MJ), T2(MJ), N1(MJ), N2(MJ)
85  DIM F(MI, 3), P(MJ, 2)
90  DIM KTT(MK, MK), KTF(MK, MN), KFT(MN, MK), R(MN)
190 '
210 GOSUB 500  '      definisce unit di ingresso e uscita
220 OPEN "I", #1, FI$
230 OPEN "O", #2, FO$
240 GOSUB 1000 '      legge dati geometrici
250 GOSUB 2000 '      stampa dati geometrici
    CALL ModGraf(Scheda)
    IF Scheda > 0 THEN
       GOSUB 2500 '   disegna schema del telaio
       IF FO$ = "PRN" THEN CALL LCOPY(Scheda, 1)
       FOR V = 1 TO 12000: NEXT V
    END IF
300 SCREEN 0
310 GOSUB 3000 '      calcola la matrice di rigidezza
320 GOSUB 5000 '      triangolarizza la matrice di rigidezza
330 WHILE NOT EOF(1)
340    INPUT #1, QN, QA
350    GOSUB 6000 '   legge i carichi
360    GOSUB 6500 '   stampa i carichi
370    GOSUB 7000 '   calcola vettore termini noti
380    GOSUB 8000 '   effettua la risoluzione del sistema
390    GOSUB 8500 '   calcola momento, taglio, sforzo normale e spostamento
400    GOSUB StampaRisultati
410 WEND
420 CLOSE #1
430 CLOSE #2
450 LOCATE 24, 1
460 PRINT "FINE ELABORAZIONE"
470 END
480 '
490 '  ----- definisce le unit di ingresso e uscita
500 PRINT "        Nome del file che contiene i dati ";
510 INPUT FI$
520 PRINT
530 PRINT "        Unit di uscita ?"
540 PRINT "        CON=schermo, PRN=stampante, oppure nome di un file"
550 PRINT "        ";
560 INPUT FO$
    FO$ = UCASE$(FO$)
    IF FO$ = "" THEN FO$ = "CON"
570 PRINT
580 RETURN
980  '
990  '  ----- effettua l'input dei dati geometrici ed elastici
1000 ER = 0
     GOSUB 1200 '                 legge indicazioni generali
     IF ER = 0 THEN GOSUB 1300'    legge dati relativi ai nodi
     IF ER = 0 THEN GOSUB 1500'    legge dati relativi ai traversi
     IF ER = 0 THEN GOSUB 1700'    legge modulo elastico e sezioni
     IF ER = 0 THEN GOSUB 1800'    legge dati relativi alle aste
     IF ER = 1 THEN STOP
     IF Contr THEN PRINT #2, "------------------------------------------------------------"
     RETURN
     '
     ' --- legge indicazioni generali
1200 INPUT #1, IT$, IZ, JZ, KZ, LZ
     IF Contr THEN
        PRINT #2, "intestazione: "; CHR$(34); IT$; CHR$(34)
        PRINT #2, "numero di nodi: "; IZ
        PRINT #2, "numero di aste: "; JZ
        PRINT #2, "numero di traversi orizzontali inestensibili: "; KZ
        PRINT #2, "numero di tipi di sezione: "; LZ
     END IF
     IF IZ > MI THEN PRINT "numero eccessivo di nodi": ER = 1
     IF JZ > MJ THEN PRINT "numero eccessivo di aste": ER = 1
     IF KZ > MK THEN PRINT "numero eccessivo di impalcati": ER = 1
     IF LZ > ML THEN PRINT "numero eccessivo di tipi sezione": ER = 1
     RETURN
     '
     ' --- legge dati relativi ai nodi
1300 IF Contr THEN PRINT #2, "dati relativi ai nodi:"
     IK = 0
     FOR I = 1 TO IZ
        INPUT #1, X(I), Y(I), V$(I)
        IF Contr THEN PRINT #2, "   nodo "; I, "x = "; X(I), "y = "; Y(I), "vincolo "; V$(I)
        FOR K = 1 TO 3
           EV$ = MID$(V$(I), K, 1)
           SELECT CASE EV$
              CASE "0", "1"
                 KV(I, K) = 0
              CASE "C", "c"
                 IK = 1
                 INPUT #1, KV(I, K)
                 IF Contr THEN PRINT #2, "      costante elastica"; K; " = "; KV(I, K)
              CASE ELSE
                 PRINT "Elemento "; K; " del codice vincolo nodo "; I; " non ammissibile"
                 ER = 1
           END SELECT
        NEXT K
     NEXT I
     RETURN
     '
     ' --- legge dati relativi a traversi inestensibili
1500 IF KZ = 0 THEN RETURN
     IF Contr THEN PRINT #2, "nodi dei traversi inestensibili:"
     I = 0
     FOR K = 1 TO KZ
        DO
           I = I + 1
           INPUT #1, NI(I)
           IF Contr AND NI(I) <> 0 THEN PRINT #2, NI(I);
        LOOP UNTIL NI(I) = 0
        IF Contr THEN PRINT #2,
     NEXT K
     RETURN
     '
     ' --- legge modulo elastico e dati delle sezioni
1700 INPUT #1, EL
     IF STecn THEN E = EL * 10 ELSE E = EL * 1000
     G = E * .45
     IF Contr THEN
        PRINT #2, "modulo elastico E = "; EL
        IF DefTag THEN PRINT #2, "calcolo con deformabilit a taglio:    G = "; G / 10
        PRINT #2, "tipi di sezione:"
     END IF
     FOR L = 1 TO LZ
        INPUT #1, ZB(L), ZH(L)
        IF Contr THEN PRINT #2, ZB(L); ZH(L),
        ZA(L) = ZB(L) * ZH(L)
        ZI(L) = ZB(L) * ZH(L) ^ 3 / 12
     NEXT L
     IF Contr THEN PRINT #2,
     RETURN
     '
     ' --- legge dati relativi alle aste
1800 IF Contr THEN PRINT #2, "dati relativi alle aste:"
     FOR J = 1 TO JZ
        INPUT #1, E1(J), E2(J), NT(J)
        IF Contr THEN PRINT #2, "   asta "; J, "   estremi: "; E1(J); E2(J), "sezione tipo: "; NT(J)
        L = NT(J)
        IF L < 1 OR L > LZ THEN PRINT "tipo di sezione inaccettabile per la trave "; J: ER = 1
        IF ER = 0 THEN SA(J) = ZA(L): SI(J) = ZI(L)
     NEXT J
     RETURN
1980 '
1990 ' ----- stampa i dati geometrici ed elastici
2000 PRINT #2, "    "; IT$
2010 '
2020 PRINT #2, : PRINT #2, : PRINT #2,
2030 PRINT #2, "    COORDINATE E VINCOLI DEI NODI": PRINT #2,
2040 PRINT #2, "    nodo      x (m)       y (m)     vincolo";
2050 IF IK = 1 THEN PRINT #2, "      rigidezza del vincolo";
2060 PRINT #2, : PRINT #2,
2070 FOR I = 1 TO IZ
2080    PRINT #2, USING "    ###    #####.##    #####.##       \ \  "; I; X(I); Y(I); V$(I);
2090    IF IK = 0 THEN 2130
2100       FOR K = 1 TO 3
2110          IF KV(I, K) <> 0 THEN PRINT #2, USING " ##.####^^^^"; KV(I, K);  ELSE PRINT #2, "       -    ";
2120       NEXT K
2130    PRINT #2,
2140 NEXT I
2150 '
2160 PRINT #2, : PRINT #2, : PRINT #2,
2170 PRINT #2, "    DATI RELATIVI ALLE TRAVI": PRINT #2,
2180 PRINT #2, "    asta   estremi       b (m)        h (m)      area (m^2)    inerzia (m^4)": PRINT #2,
2190 FOR J = 1 TO JZ
2200    L = NT(J)
2210    PRINT #2, USING "   ####   ### ###     #####.##     #####.##    #####.####    #####.######"; J; E1(J); E2(J); ZB(L); ZH(L); SA(J); SI(J)
2220 NEXT J
2230 '
2240 PRINT #2, : PRINT #2, : PRINT #2,
     IF STecn THEN
        PRINT #2, "    Modulo di elasticit = "; EL; " kg/cm2"
        IF DefTag THEN PRINT #2, "    Modulo di elasticit tangenziale = "; G / 10; " kg/cm2"
     ELSE
        PRINT #2, "    Modulo di elasticit = "; EL; " N/mm2 "
        IF DefTag THEN PRINT #2, "    Modulo di elasticit tangenziale = "; G / 10; " N/mm2 "
     END IF
2260 '
2270 RETURN
2470 '
2480 ' ----- disegna lo schema del telaio
2490 ' determina i valori limite di X ed Y
2500 X1 = X(1)
2510 X2 = X(1)
2520 Y1 = Y(1)
2530 Y2 = Y(1)
2540 FOR I = 2 TO IZ
2550    IF X1 > X(I) THEN X1 = X(I)
2560    IF X2 < X(I) THEN X2 = X(I)
2570    IF Y1 > Y(I) THEN Y1 = Y(I)
2580    IF Y2 < Y(I) THEN Y2 = Y(I)
2590 NEXT I
2600 '      individua la scala del disegno
2610 GOSUB 2800
2620 WINDOW (X1, Y1)-(X2, Y2)
2630 '      ciclo di graficizzazione
2640 FOR J = 1 TO JZ
2650    LINE (X(E1(J)), Y(E1(J)))-(X(E2(J)), Y(E2(J)))
2660 NEXT J
2670 '      fine
2680 RETURN
2780 '
2790 ' --- definizione scala per rappresentazione monometrica
2800 FX = .125
2810 FY = .075
2820 SC = (X2 - X1) / FX
2830 IF SC < (Y2 - Y1) / FY THEN SC = (Y2 - Y1) / FY
2840 LX = FX * SC
2850 LY = FY * SC
2860 XC = (X1 + X2) / 2
2870 YC = (Y1 + Y2) / 2
2880 X1 = XC - LX / 2
2890 X2 = XC + LX / 2
2900 Y1 = YC - LY / 2
2910 Y2 = YC + LY / 2
2920 RETURN
2980 '
2990 ' ----- calcola la matrice di rigidezza della struttura
3000 GOSUB 3100 '        conta e numera le incognite
3005 GOSUB 3300 '        calcola ampiezza semibanda
3010 GOSUB 3500 '        azzera matrice di rigidezza
3015 FOR J = 1 TO JZ
3020    GOSUB 4000 '     calcola le matrici "N" ed "LD" per l'asta "J"
3025    GOSUB 4300 '     calcola le matrici "T", "Kf" e "Kg" per l'asta "J"
3030    GOSUB 3600 '     inserisce termini nella matr. di rigid. della struttura
3035 NEXT J
3040 IF IK = 1 THEN GOSUB 3700'    aggiunge termini per vincoli cedevoli
3045 RETURN
3080 '
3085 ' --- numerazione automatica delle incognite
3090 ' inizializzazione G(,)
3100 FOR I = 1 TO IZ
3105    FOR K = 1 TO 3
3110       G(I, K) = -1
3115    NEXT K
3120 NEXT I
3125 ' prima fase - spostamenti impalcati
3130 N = 0
3135 IF KZ = 0 THEN 3220
3140    I1 = 1
3145    FOR K = 1 TO KZ
3150       I = I1
3155       VN = N + 1
3160       WHILE NI(I) <> 0
3165          IF MID$(V$(NI(I)), 1, 1) = "1" THEN VN = 0
3170          I = I + 1
3175       WEND
3180       I = I1
3185       WHILE NI(I) <> 0
3190          G(NI(I), 1) = VN
3195          I = I + 1
3200       WEND
3205       I1 = I + 1
3210       IF VN <> 0 THEN N = N + 1
3215    NEXT K
3220 NL = N
3225 ' seconda fase - altre incognite
3230 FOR I = 1 TO IZ
3235    FOR K = 1 TO 3
3240       IF G(I, K) <> -1 THEN 3250
3245          IF MID$(V$(I), K, 1) = "1" THEN G(I, K) = 0 ELSE N = N + 1: G(I, K) = N
3250    NEXT K
3255 NEXT I
3260 NZ = N
3265 IF NZ > MN THEN PRINT "numero eccessivo di incognite": STOP
3270 RETURN
3280 '
3290 ' --- calcola l'ampiezza della semibanda e dimensiona KFF()
3300 SB = 0
3305 FOR J = 1 TO JZ
3310    I1 = E1(J)
3315    I2 = E2(J)
3320    G1 = NZ
3325    G2 = NL
3330    FOR K = 1 TO 3
3335       IF G(I1, K) <= NL THEN 3350
3340          IF G1 > G(I1, K) THEN G1 = G(I1, K)
3345          IF G2 < G(I1, K) THEN G2 = G(I1, K)
3350       IF G(I2, K) <= NL THEN 3365
3355          IF G1 > G(I2, K) THEN G1 = G(I2, K)
3360          IF G2 < G(I2, K) THEN G2 = G(I2, K)
3365    NEXT K
3370    IF G2 > G1 AND SB < G2 - G1 THEN SB = G2 - G1
3375 NEXT J
3380 BB = 2 * SB + 1
3382 RZ = BB * (NZ - NL)
3384 PRINT
3386 PRINT USING "#### incognite (compresi ## spostamenti di traversi)"; NZ; NL
3388 PRINT USING "semibanda: ####           banda: ####"; SB; BB
3390 DIM KFF(NZ - NL, BB)
3392 PRINT
3395 RETURN
3480 '
3490 ' --- azzera matrice di rigidezza
3500 FOR R = 1 TO NL
3505    FOR C = 1 TO NL
3510       KTT(R, C) = 0
3515    NEXT C
3520 NEXT R
3525 FOR R = 1 TO NL
3530    FOR C = 1 TO NZ - NL
3535       KTF(R, C) = 0
3540       KFT(C, R) = 0
3545    NEXT C
3550 NEXT R
3555 FOR rig = 1 TO NZ - NL
3556    FOR col = 1 TO BB
3560       KFF(rig, col) = 0
3564    NEXT col
3565 NEXT rig
3570 RETURN
3580 '
3590 ' --- contributo dell'asta "J" alla matrice di rigidezza della struttura
3600 FOR R = 1 TO 6
3605    P = N(R)
3610    IF P = 0 THEN 3635
3615       FOR C = 1 TO 6
3620          Q = N(C)
3625          IF Q <> 0 THEN V = KG(R, C): GOSUB 4700
3630       NEXT C
3635 NEXT R
3640 RETURN
3680 '
3690 ' --- aggiunge rigid. dei vincoli cedevoli alla m.d.r.
3700 FOR I = 1 TO IZ
3705    FOR K = 1 TO 3
3710       IF G(I, K) <> 0 THEN P = G(I, K): Q = P: V = KV(I, K): GOSUB 4700
3715    NEXT K
3720 NEXT I
3725 RETURN
3780 '
3790 ' ----- modifica KFF per deformabilit a taglio
3800 EP = 8 * SI(J) / SA(J) / LA ^ 2    '  8 vale per G=0.45*E  e CHI=1.2
3810 KF(1, 1) = KF(1, 1) * (1 + EP) / (1 + 4 * EP)
3820 KF(2, 2) = KF(1, 1)
3830 KF(1, 2) = KF(1, 2) * (1 - 2 * EP) / (1 + 4 * EP)
3840 KF(2, 1) = KF(1, 2)
3850 RETURN
3980 '
3990 ' ----- calcola le matrici "N" ed "LD" per l'asta "J"
4000 DX = X(E2(J)) - X(E1(J))
4010 DY = Y(E2(J)) - Y(E1(J))
4020 LA = SQR(DX ^ 2 + DY ^ 2)
4030 SN = DY / LA
4040 CS = DX / LA
4050 FOR K = 1 TO 3
4060    N(K) = G(E1(J), K)
4070    N(K + 3) = G(E2(J), K)
4080 NEXT K
4090 FOR I = 1 TO 6
4100    FOR L = 1 TO 6
4110       LD(I, L) = 0
4120    NEXT L
4130 NEXT I
4140 LD(1, 1) = CS
4150 LD(2, 2) = CS
4160 LD(4, 4) = CS
4170 LD(5, 5) = CS
4180 LD(1, 2) = -SN
4190 LD(2, 1) = SN
4200 LD(4, 5) = -SN
4210 LD(5, 4) = SN
4220 LD(3, 3) = 1
4230 LD(6, 6) = 1
4240 RETURN
4280 '
4290 ' ----- calcola le matrici "T", "Kf" e "Kg" per l'asta "J"
4300 FOR I = 1 TO 6
4305    FOR L = 1 TO 3
4310       T(I, L) = 0
4315    NEXT L
4320 NEXT I
4325 T(1, 3) = -1
4330 T(2, 1) = 1 / LA
4335 T(2, 2) = T(2, 1)
4340 T(3, 1) = 1
4345 T(4, 3) = 1
4350 T(5, 1) = -(1 / LA)
4355 T(5, 2) = T(5, 1)
4360 T(6, 2) = 1
4365 FOR I = 1 TO 3
4370    FOR L = 1 TO 3
4375       KF(I, L) = 0
4380    NEXT L
4385 NEXT I
4390 KF(1, 1) = 4 * E * SI(J) / LA
4395 KF(2, 2) = KF(1, 1)
4400 KF(1, 2) = 2 * E * SI(J) / LA
4405 KF(2, 1) = KF(1, 2)
4410 KF(3, 3) = E * SA(J) / LA
4412 IF DefTag THEN GOSUB 3800
4415 '  MAT ATX=LD*T
4420 FOR I = 1 TO 6
4425    FOR L = 1 TO 3
4430       ATX(I, L) = 0
4435       FOR K = 1 TO 6
4440          ATX(I, L) = ATX(I, L) + LD(I, K) * T(K, L)
4445       NEXT K
4450    NEXT L
4455 NEXT I
4460 '  MAT A=TRN(ATX)
4465 FOR I = 1 TO 3
4470    FOR L = 1 TO 6
4475       A(I, L) = ATX(L, I)
4480    NEXT L
4485 NEXT I
4490 '  MAT AT=ATX*KF
4495 FOR I = 1 TO 6
4500    FOR L = 1 TO 3
4505       AT(I, L) = 0
4510       FOR K = 1 TO 3
4515          AT(I, L) = AT(I, L) + ATX(I, K) * KF(K, L)
4520       NEXT K
4525    NEXT L
4530 NEXT I
4535 '  MAT KG=AT*A
4540 FOR I = 1 TO 6
4545    FOR L = 1 TO 6
4550       KG(I, L) = 0
4555       FOR K = 1 TO 3
4560          KG(I, L) = KG(I, L) + AT(I, K) * A(K, L)
4565       NEXT K
4570    NEXT L
4575 NEXT I
4580 RETURN
4680 '
4690 ' --- inserisce valore nella matrice di rigidezza
4700 IF P <= NL AND Q <= NL THEN 4740
4710 IF P <= NL AND Q > NL THEN 4760
4720 IF P > NL AND Q <= NL THEN 4780
4730 GOTO 4800
4740    KTT(P, Q) = KTT(P, Q) + V
4750 GOTO 4830
4760    KTF(P, Q - NL) = KTF(P, Q - NL) + V
4770 GOTO 4830
4780    KFT(P - NL, Q) = KFT(P - NL, Q) + V
4790 GOTO 4830
4800    RR = (P - NL - 1) * BB + Q - P + (BB + 1) / 2
4802    rig = INT((RR - 1) / BB) + 1
4804    col = RR - BB * (rig - 1)
4810    KFF(rig, col) = KFF(rig, col) + V
4820 GOTO 4830
4830 RETURN
4980 '
4990 ' --- effettua la riduzione del sistema
5000 FOR I = NZ - NL TO 1 STEP -1
5010    SS = I * BB - SB
5012    rig1 = INT((SS - 1) / BB) + 1
5014    col1 = SS - BB * (rig1 - 1)
5020    IF I - 1 < SB THEN SC = I - 1 ELSE SC = SB
5030    IF SC = 0 THEN 5140
5040       FOR J = 1 TO SC
5050          ST = SS - J * (BB - 1)
5052          rig = INT((ST - 1) / BB) + 1
5054          col = ST - BB * (rig - 1)
5060          KFF(rig, col) = -KFF(rig, col) / KFF(rig1, col1)' rapporto azzerante
5070          FOR M = 1 TO SC
5072             rig2 = INT((ST - M - 1) / BB) + 1
5074             col2 = ST - M - BB * (rig2 - 1)
5076             rig3 = INT((SS - M - 1) / BB) + 1
5078             col3 = SS - M - BB * (rig3 - 1)
5080             KFF(rig2, col2) = KFF(rig2, col2) + KFF(rig3, col3) * KFF(rig, col)
5090          NEXT M
5100          FOR M = 1 TO NL
5110             KFT(I - J, M) = KFT(I - J, M) + KFT(I, M) * KFF(rig, col)
5120          NEXT M
5130       NEXT J
5140    FOR J = 1 TO NL
5150       KTF(J, I) = -KTF(J, I) / KFF(rig1, col1)' rapporto azzerante
5160       IF SC = 0 THEN 5200
5170          FOR M = 1 TO SC
5176             rig3 = INT((SS - M - 1) / BB) + 1
5178             col3 = SS - M - BB * (rig3 - 1)
5180             KTF(J, I - M) = KTF(J, I - M) + KFF(rig3, col3) * KTF(J, I)
5190          NEXT M
5200       FOR M = 1 TO NL
5210          KTT(J, M) = KTT(J, M) + KFT(I, M) * KTF(J, I)
5220       NEXT M
5230    NEXT J
5240 NEXT I
5250 '
5260 FOR I = NL TO 2 STEP -1
5270    FOR J = I - 1 TO 1 STEP -1
5280       KTT(J, I) = -KTT(J, I) / KTT(I, I)' rapporto azzerante
5290       FOR M = I - 1 TO 1 STEP -1
5300          KTT(J, M) = KTT(J, M) + KTT(I, M) * KTT(J, I)
5310       NEXT M
5320    NEXT J
5330 NEXT I
5340 RETURN
5980 '
5990 ' ----- legge i carichi nodali e sulle aste
6000 IF Contr THEN PRINT #2, "------------------------------------------------------------"
     FOR I = 1 TO IZ
        F(I, 1) = 0
        F(I, 2) = 0
        F(I, 3) = 0
     NEXT I
     FOR J = 1 TO JZ
        P(J, 1) = 0
        P(J, 2) = 0
     NEXT J
     IF NOT (QN = 0) THEN
        IF Contr THEN PRINT #2, QN; "carichi nodali:"
        ' - modifiche 19/1/93:
        REDIM NIMP(QN), FIMP(QN), TIMP(QN), SAIMP(QN), SRIMP(QN), RIMP(QN)
        FOR Q = 1 TO QN
           INPUT #1, I, F(I, 1), F(I, 2), F(I, 3)
           IF Contr THEN PRINT #2, "   nodo "; I, "Fx = "; F(I, 1), "Fy = "; F(I, 2), "M = "; F(I, 3)
           ' - modifiche 19/1/93:
           NIMP(Q) = I: FIMP(Q) = F(I, 1)
        NEXT Q
        ' - modifiche 19/1/93:
        TIMP(QN) = FIMP(QN)
        FOR Q = QN - 1 TO 1 STEP -1
           TIMP(Q) = TIMP(Q + 1) + FIMP(Q)
        NEXT Q
     END IF
     IF NOT (QA = 0) THEN
        IF Contr THEN PRINT #2, QA; "carichi distribuiti sulle aste:"
        FOR Q = 1 TO QA
           INPUT #1, J, P(J, 1), P(J, 2)
           IF Contr THEN PRINT #2, "   asta "; J, "px = "; P(J, 1), "py = "; P(J, 2)
        NEXT Q
     END IF
     IF Contr THEN PRINT #2, "------------------------------------------------------------"
     RETURN
6480 '
6490 ' ----- stampa i carichi nodali e sulle aste
6500 PRINT #2, : PRINT #2, : PRINT #2,
6520 IF QN = 0 THEN 6600
        IF STecn THEN
           A$ = "    nodo        Fx (t)       Fy (t)       M (tm)"
           B$ = "    ######.##"
        ELSE
           A$ = "    nodo       Fx (kN)      Fy (kN)      M (kNm)"
           B$ = "    #######.#"
        END IF
6530    PRINT #2, "    CARICHI NODALI": PRINT #2,
6540    PRINT #2, A$: PRINT #2,
6550    FOR I = 1 TO IZ
6560       IF F(I, 1) = 0 AND F(I, 2) = 0 AND F(I, 3) = 0 THEN 6580
6570          PRINT #2, USING "    ### "; I;
              PRINT #2, USING B$; F(I, 1); F(I, 2); F(I, 3)
6580    NEXT I
6590    PRINT #2, : PRINT #2,
6600 IF QA = 0 THEN 6670
        IF STecn THEN
           A$ = "    asta       px (t/m)     py (t/m)"
           B$ = "    ######.##"
        ELSE
           A$ = "    asta       px (kN/m)    py (kN/m)"
           B$ = "    #######.#"
        END IF
6610    PRINT #2, "    CARICHI SULLE ASTE": PRINT #2,
6620    PRINT #2, A$: PRINT #2,
6630    FOR J = 1 TO JZ
6640       IF P(J, 1) = 0 AND P(J, 2) = 0 GOTO 6660
6650          PRINT #2, USING "    ### "; J;
              PRINT #2, USING B$; P(J, 1); P(J, 2)
6660    NEXT J
6670 RETURN
6980 '
6990 ' ----- calcola il vettore carichi nodali
7000 FOR N = 1 TO NZ
7010    R(N) = 0
7020 NEXT N
7030 FOR I = 1 TO IZ
7040    FOR K = 1 TO 3
7050       P = G(I, K)
7060       IF P <> 0 THEN R(P) = R(P) + F(I, K)
7070    NEXT K
7080 NEXT I
7090 FOR J = 1 TO JZ
7100    IF P(J, 1) = 0 AND P(J, 2) = 0 THEN 7160
7110       GOSUB 4000 '     calcola le matrici "N" ed "LD" per l'asta "J"
7120       GOSUB 7500 '     calcola le azioni di incastro perfetto sull'asta
7130       FOR K = 1 TO 6
7140          IF N(K) <> 0 THEN R(N(K)) = R(N(K)) - SS(K)
7150       NEXT K
7160 NEXT J
7170 RETURN
7480 '
7490 ' ----- calcola il vettore azioni di incastro perfetto per la trave "J"
7500 PX = CS * P(J, 1) + SN * P(J, 2)
7510 PY = -(SN * P(J, 1)) + CS * P(J, 2)
7520 SSX(1) = -(PX * LA / 2)
7530 SSX(2) = -(PY * LA / 2)
7540 SSX(3) = -(PY * LA ^ 2 / 12)
7550 SSX(4) = SSX(1)
7560 SSX(5) = SSX(2)
7570 SSX(6) = -SSX(3)
7580 FOR I = 1 TO 6
7590    SS(I) = 0
7600 NEXT I
7610 FOR I = 1 TO 6
7620    FOR K = 1 TO 6
7630       SS(I) = SS(I) + LD(I, K) * SSX(K)
7640    NEXT K
7650 NEXT I
7660 RETURN
7980 '
7990 ' --- calcolo del vettore soluzione
8000 FOR I = NZ - NL TO 1 STEP -1
8010    SS = I * BB - SB
8020    IF I - 1 < SB THEN SC = I - 1 ELSE SC = SB
8030    IF SC = 0 THEN 8080
8040       FOR J = 1 TO SC
8050          ST = SS - J * (BB - 1)
8052          rig = INT((ST - 1) / BB) + 1
8054          col = ST - BB * (rig - 1)
8060          R(I - J + NL) = R(I - J + NL) + R(I + NL) * KFF(rig, col)
8070       NEXT J
8080    FOR J = 1 TO NL
8090       R(J) = R(J) + R(I + NL) * KTF(J, I)
8100    NEXT J
8110 NEXT I
8120 FOR I = NL TO 2 STEP -1
8130    FOR J = I - 1 TO 1 STEP -1
8140       R(J) = R(J) + R(I) * KTT(J, I)
8150    NEXT J
8160 NEXT I
8170 '
8180 FOR I = 1 TO NL
8190    S = R(I)
8200    IF I = 1 THEN 8240
8210       FOR J = 1 TO I - 1
8220          S = S - KTT(I, J) * R(J)
8230       NEXT J
8240    R(I) = S / KTT(I, I)
8250 NEXT I
8260 FOR I = 1 TO NZ - NL
8270    S = R(I + NL)
8280    FOR J = 1 TO NL
8290       S = S - KFT(I, J) * R(J)
8300    NEXT J
8310    SS = I * BB - SB
8320    IF I - 1 < SB THEN SC = I - 1 ELSE SC = SB
8330    IF SC = 0 THEN 8370
8340       FOR J = 1 TO SC
8346          rig3 = INT((SS - J - 1) / BB) + 1
8348          col3 = SS - J - BB * (rig3 - 1)
8350          S = S - KFF(rig3, col3) * R(I - J + NL)
8360       NEXT J
8370    rig1 = INT((SS - 1) / BB) + 1
8372    col1 = SS - BB * (rig1 - 1)
8378    R(I + NL) = S / KFF(rig1, col1)
8380 NEXT I
8390 RETURN
8480 '
8490 ' ----- calcola le azioni sulle aste
8500 FOR J = 1 TO JZ
8510    GOSUB 4000 '     calcola le matrici "N" ed "LD" per l'asta "J"
8520    GOSUB 4300 '     calcola le matrici "T", "Kf" e "Kg" per l'asta "J"
8530    FOR K = 1 TO 6
8540       IF N(K) = 0 THEN S1(K) = 0 ELSE S1(K) = R(N(K))
8550    NEXT K
8560    FOR I = 1 TO 6
8570       S(I) = 0
8580    NEXT I
8590    FOR I = 1 TO 6
8600       FOR K = 1 TO 6
8610          S(I) = S(I) + KG(I, K) * S1(K)
8620       NEXT K
8630    NEXT I
8640    GOSUB 7500 '     calcola le azioni di incastro perfetto
8650    FOR I = 1 TO 6
8660       S(I) = S(I) + SS(I)
8670    NEXT I
8680    FOR K = 1 TO 3
8690       F(E1(J), K) = F(E1(J), K) - S(K)
8700       F(E2(J), K) = F(E2(J), K) - S(K + 3)
8710    NEXT K
8720    FOR I = 1 TO 6
8730       FOR L = 1 TO 6
8740          LDT(I, L) = LD(L, I)
8750       NEXT L
8760    NEXT I
8770    FOR I = 1 TO 6
8780       SX(I) = 0
8790    NEXT I
8800    FOR I = 1 TO 6
8810       FOR K = 1 TO 6
8820          SX(I) = SX(I) + LDT(I, K) * S(K)
8830       NEXT K
8840    NEXT I
8850    N1(J) = -SX(1)
8860    T1(J) = SX(2)
8870    M1(J) = -SX(3)
8880    N2(J) = SX(4)
8890    T2(J) = -SX(5)
8900    M2(J) = SX(6)
8910 NEXT J
8920 RETURN

StampaRisultati:
   ' ----- stampa i risultati
   PRINT #2, : PRINT #2, : PRINT #2,
   PRINT #2, "    SPOSTAMENTI E ROTAZIONI DEI NODI": PRINT #2,
   PRINT #2, "    nodo        Vx (cm)    Vy (cm)   rotaz.x100": PRINT #2,
   FOR I = 1 TO IZ
      FOR K = 1 TO 3
         IF G(I, K) = 0 THEN V(K) = 0 ELSE V(K) = R(G(I, K)) * 100
      NEXT K
      PRINT #2, USING "    ###       ####.####  ####.####  ####.####"; I; V(1); V(2); V(3)
   NEXT I
   IF STecn THEN
      A$ = "    asta      M1 (tm)    M2 (tm)     T1 (t)     T2 (t)     N1 (t)     N2 (t)"
      B$ = "#######.###"
      C$ = "    nodo        Fx (t)       Fy (t)       M (tm)"
   ELSE
      A$ = "    asta      M1(kNm)    M2(kNm)     T1(kN)     T2(kN)     N1(kN)     N2(kN)"
      B$ = "########.##"
      C$ = "    nodo        Fx(kN)       Fy(kN)       M(kNm)"
   END IF
   PRINT #2, : PRINT #2, : PRINT #2,
   PRINT #2, "    CARATTERISTICHE DI SOLLECITAZIONE NELLE ASTE": PRINT #2,
   PRINT #2, A$: PRINT #2,
   FOR J = 1 TO JZ
      PRINT #2, USING "    ###   "; J;
      PRINT #2, USING B$; M1(J); M2(J); T1(J); T2(J); N1(J); N2(J)
   NEXT J
   PRINT #2, : PRINT #2, : PRINT #2,
   PRINT #2, "    AZIONI SUI VINCOLI ( ED EVENTUALE SQUILIBRIO DEI NODI )": PRINT #2,
   PRINT #2, C$: PRINT #2,
   FOR I = 1 TO IZ
      IF ABS(F(I, 1)) + ABS(F(I, 2)) + ABS(F(I, 3)) > SqAm THEN
         PRINT #2, USING "    ###  "; I;
         PRINT #2, USING "##" + B$; F(I, 1); F(I, 2); F(I, 3)
      END IF
   NEXT I
   PRINT #2, : PRINT #2,
   IF CalcRig = 1 THEN
      PRINT #2, "RIGIDEZZA DEL TELAIO AI VARI PIANI"
      PRINT #2,
      PRINT #2, "piano   taglio    spost.rel.    rigidezza"
      PRINT #2,
      FOR Q = 1 TO QN
         SAIMP(Q) = R(G(NIMP(Q), 1))
         IF Q = 1 THEN
            SRIMP(Q) = SAIMP(Q)
         ELSE
            SRIMP(Q) = SAIMP(Q) - SAIMP(Q - 1)
         END IF
         RIMP(Q) = TIMP(Q) / SRIMP(Q)
         PRINT #2, USING " ##    #####.##   ####.####   ######.####"; Q; TIMP(Q); SRIMP(Q) * 100; RIMP(Q) * .001
      NEXT Q
      PRINT #2, : PRINT #2,
   END IF
RETURN

SUB tolto

95  '
100 KEY OFF
110 CLS
120 PRINT TAB(31); "TELMAT - rev. 06.89"
130 PRINT
140 PRINT "        Le ipotesi  di calcolo  e le  modalit  operative  del programma"
150 PRINT "        TELMAT sono riportate nella terza parte,  capitolo 5,  del libro:"
160 PRINT "        A.Ghersi, Edifici antisismici con struttura intelaiate in cemento"
170 PRINT "        armato, CUEN, Napoli, 1988."
180 PRINT
182 PRINT USING "        Limiti del programma:  ### nodi    ### aste   ### tipi di sezione"; MI; MJ; ML
184 PRINT USING "                               ### traversi inestensibili   ### incognite"; MK; MN
186 PRINT "                             banda diagonale dimensionata automaticamente"
188 PRINT : PRINT

END SUB

