'                                  TELPIA.BAS

'  versione 1.4 per QBASIC                                     rev. 11.93

CONST SisTec = 0, SisInt = 1

CLS
PRINT "                  TELPIA - vers. 1.4                 rev. 11.93"
PRINT : PRINT
PRINT "        Le ipotesi  di calcolo  e le  modalit  operative  del  programma"
PRINT "        TELPIA sono riportate nella terza parte,  capitolo 4,  del libro:"
PRINT "        A.Ghersi, Edifici antisismici con struttura intelaiate in cemento"
PRINT "        armato, CUEN, Napoli, 1986-1991."
PRINT
PRINT "        La presente versione,  in aggiunta  a quanto indicato  nel libro,"
PRINT "        consente  di mandare in esecuzione  il programma  con le seguenti"
PRINT "        opzioni:"
PRINT "           /I     se dati e risultati  sono nel sistema internazionale"
PRINT "                    (unit base kN e m, per il modulo elastico N/mm)"
PRINT "           /C     per far stampare  i dati man mano  che vengono letti"
PRINT "                    (utile per individuare  eventuali errori di input)"
PRINT "           /R     per calcolare la rigidezza dei telai ad ogni piano"
PRINT

C$ = UCASE$(COMMAND$)
IF INSTR(C$, "/SI") <> 0 THEN Unit = SisInt ELSE Unit = SisTec
Contr = INSTR(C$, "/C")
IF INSTR(C$, "/R") = 0 THEN CalcRig = 0 ELSE CalcRig = 1
IF Unit = SisTec THEN SqAm = .0005 ELSE SqAm = .005

OPTION BASE 1 '   definisce l'estremo inferiore dell'indice degli array
MI = 120: MK = 10: ML = 50
DIM DL(MI - 1), HI(MK), H(MI, MK), NP(MI), ZB(ML), ZH(ML), ZI(ML)
DIM NT(MI - 1, MK), NR(MI, MK), WT(MI - 1, MK), WR(MI, MK), WN(MI, MK)
DIM WX(MK), Q(MI - 1, MK), MN(MI, MK), FX(MK), SM(MI, MK), QX(MK)
DIM Fi(MI, MK), D(MK)
DIM MS(MI - 1, MK), MD(MI - 1, MK), MT(MI, MK), MP(MI, MK)
DIM TS(MI - 1, MK), TD(MI - 1, MK), TR(MI, MK), SN(MI, MK)
'
GOSUB 500  '      definisce unit di ingresso e uscita
OPEN Fi$ FOR INPUT AS #1
OPEN Fo$ FOR OUTPUT AS #2
GOSUB 1000 '      legge dati geometrici
GOSUB 2000 '      stampa dati geometrici
IF CalcRig = 1 THEN GOSUB DistinguiTelai
GOSUB 3000 '      calcola indici di rigidezza e loro somma
DO WHILE NOT EOF(1)
   INPUT #1, IV
   IF EOF(1) THEN EXIT DO
   INPUT #1, IM
   IF EOF(1) THEN EXIT DO
   INPUT #1, IO
   IF IV = 0 AND IM = 0 AND IO = 0 THEN EXIT DO
   GOSUB 4000 '   legge i carichi
   GOSUB 5000 '   stampa i carichi
   GOSUB 6000 '   calcola somma mom.inc. e somma forze
   GOSUB 7000 '   effettua la risoluzione iterativa del sistema
   GOSUB 8000 '   calcola momento, taglio, sforzo normale e spostamento
   GOSUB 9000 '   stampa i risultati
   IF CalcRig = 1 THEN GOSUB Rigidezze
LOOP
CLOSE #1
CLOSE #2
LOCATE 23, 1
PRINT "Fine elaborazione"
END

'  ----- definisce le unit di ingresso e uscita
500
   PRINT "        Nome del file che contiene i dati ";
   INPUT Fi$
   PRINT
   PRINT "        Unit di uscita ?"
   PRINT "        CON=schermo, PRN=stampante, oppure nome di un file"
   PRINT "        ";
   INPUT Fo$
   Fo$ = UCASE$(Fo$)
   IF Fo$ = "" THEN Fo$ = "CON"
   PRINT
RETURN

'  ----- effettua l'input dei dati geometrici ed elastici
1000
   INPUT #1, IT$, KZ, LZ
   IF Contr THEN
      PRINT #2, "intestazione: " + CHR$(34) + IT$ + CHR$(34)
      PRINT #2, "numero di piani: "; KZ
      PRINT #2, "numero di tipi di sezione: "; LZ
   END IF
   IF KZ > MK THEN PRINT "NUMERO ECCESSIVO DI PIANI": STOP
   IF LZ > ML THEN PRINT "NUMERO ECCESSIVO DI TIPI DI SEZIONE": STOP
   '
   IF Contr THEN PRINT #2, "numerazione dei pilastri:"
   I = 0
   INPUT #1, N
   WHILE N <> 0
      IF I = MI THEN PRINT "NUMERO ECCESSIVO DI PILASTRI": STOP
      I = I + 1
      NP(I) = N
      IF Contr THEN PRINT #2, NP(I);
      INPUT #1, N
   WEND
   IF Contr THEN PRINT #2,
   IZ = I
   IF Contr THEN PRINT #2, "numero totale di pilastri: "; IZ
   '
   IF Contr THEN PRINT #2, "altezza dei piani:"
   KC = 0
   FOR K = KZ TO 1 STEP -1
      INPUT #1, HI(K)
      IF Contr THEN PRINT #2, HI(K);
      IF HI(K) > 0 THEN KC = KC + 1
   NEXT K
   IF Contr THEN PRINT #2,
   FOR K = KZ TO 1 STEP -1
      IF HI(K) > 0 THEN
         FOR I = 1 TO IZ
            H(I, K) = HI(K)
         NEXT I
      ELSE
         IF Contr THEN PRINT #2, "altezza dei ritti dell'interpiano "; K; ":"
         FOR I = 1 TO IZ
            INPUT #1, H(I, K)
            IF Contr THEN PRINT #2, H(I, K);
         NEXT I
         IF Contr THEN PRINT #2,
      END IF
   NEXT K
   '
   IF Contr THEN PRINT #2, "luce delle campate:"
   FOR I = 1 TO IZ - 1
      INPUT #1, DL(I)
      IF Contr THEN PRINT #2, DL(I);
   NEXT I
   IF Contr THEN PRINT #2,
   '
   INPUT #1, EL
   IF Contr THEN PRINT #2, "modulo di elasticita`: "; EL
   IF Unit = SisTec THEN E = EL * 10 ELSE E = EL * 1000
   '
   IF Contr THEN PRINT #2, "tipi di sezione:"
   FOR L = 1 TO LZ
      INPUT #1, ZB(L), ZH(L)
      IF Contr THEN PRINT #2, ZB(L); ZH(L),
      ZI(L) = ZB(L) * ZH(L) ^ 3 / 12
   NEXT L
   IF Contr THEN PRINT #2,
   '
   ER = 0
   FOR K = KZ TO 1 STEP -1
      IF Contr THEN PRINT #2, "travi dell'impalcato "; K; ":"
      FOR I = 1 TO IZ - 1
         INPUT #1, NT(I, K)
         IF Contr THEN PRINT #2, NT(I, K);
         IF NT(I, K) < 1 OR NT(I, K) > LZ THEN PRINT "TIPO DI SEZIONE INACCETTABILE PER LA  TRAVE"; I; K: ER = 1
      NEXT I
      IF Contr THEN PRINT #2,
   NEXT K
   '
   FOR K = KZ TO 1 STEP -1
      IF Contr THEN PRINT #2, "ritti dell'interpiano "; K; ":"
      FOR I = 1 TO IZ
         INPUT #1, NR(I, K)
         IF Contr THEN PRINT #2, NR(I, K);
         IF NR(I, K) < 1 OR NR(I, K) > LZ THEN PRINT "TIPO DI SEZIONE INACCETTABILE PER IL RITTO"; I; K: ER = 1
      NEXT I
      IF Contr THEN PRINT #2,
   NEXT K
   IF Contr THEN PRINT #2, "------------------------------------------------------------"
   IF ER = 1 THEN STOP
   '
RETURN

' ----- stampa i dati geometrici ed elastici
2000
   PRINT #2, "    "; IT$: PRINT #2, : PRINT #2, : PRINT #2,
   '
   PRINT #2, "    ALTEZZA DEI PIANI"
   PRINT #2, : PRINT #2, "    piano     altezza (m)": PRINT #2,
   FOR K = KZ TO 1 STEP -1
      PRINT #2, USING "    ###     "; K;
      IF HI(K) > 0 THEN PRINT #2, USING "#####.##"; HI(K) ELSE PRINT #2, "  variabile"
   NEXT K
   IF KC <> KZ THEN
      IF IZ > 4 THEN KV = 4 ELSE KV = IZ
      PRINT #2, : PRINT #2,
      PRINT #2, "    piano   ";
      FOR K = 1 TO KV
         PRINT #2, "   pil.  altezza";
      NEXT K
      PRINT #2,
      PRINT #2, "            ";
      FOR K = 1 TO KV
         PRINT #2, "           (m)  ";
      NEXT K
      PRINT #2, : PRINT #2,
      FOR K = KZ TO 1 STEP -1
         IF HI(K) = 0 THEN
            PRINT #2, USING "     ##     "; K;
            FOR I = 1 TO IZ
               IF I MOD 4 = 1 AND I > 1 THEN PRINT #2, : PRINT #2, "            ";
               PRINT #2, USING "   ###   ###.## "; NP(I); H(I, K);
            NEXT I
            PRINT #2, : PRINT #2,
         END IF
      NEXT K
   END IF
   '
   PRINT #2, : PRINT #2, : PRINT #2,
   PRINT #2, "    LUCI E SEZIONI DELLE TRAVI": PRINT #2,
   PRINT #2, "     campata   luce   piano   B     H    inerzia";
   IF KZ > 1 THEN PRINT #2, "  piano   B     H    inerzia";
   PRINT #2,
   PRINT #2, "                (m)          (m)   (m)    (m^4) ";
   IF KZ > 1 THEN PRINT #2, "         (m)   (m)    (m^4) ";
   PRINT #2, : PRINT #2,
   FOR I = 1 TO IZ - 1
      PRINT #2, USING "    ### -###  ##.## "; NP(I); NP(I + 1); DL(I);
      FOR K = KZ TO 1 STEP -1
         L = NT(I, K)
         IF (KZ - K) MOD 2 = 0 AND K < KZ THEN PRINT #2, : PRINT #2, "                    ";
         PRINT #2, USING "   ##  ##.## ##.## ##.######"; K; ZB(L); ZH(L); ZI(L);
     NEXT K
     PRINT #2, : PRINT #2,
   NEXT I
   '
   PRINT #2, : PRINT #2, : PRINT #2,
   PRINT #2, "    SEZIONI DEI PILASTRI": PRINT #2,
   PRINT #2, "    pilastro          piano   B     H    inerzia";
   IF KZ > 1 THEN PRINT #2, "  piano   B     H    inerzia";
   PRINT #2,
   PRINT #2, "                             (m)   (m)    (m^4) ";
   IF KZ > 1 THEN PRINT #2, "         (m)   (m)    (m^4) ";
   PRINT #2, : PRINT #2,
   FOR I = 1 TO IZ
      PRINT #2, USING "      ###           "; NP(I);
      FOR K = KZ TO 1 STEP -1
         L = NR(I, K)
         IF (KZ - K) MOD 2 = 0 AND K < KZ THEN PRINT #2, : PRINT #2, "                    ";
         PRINT #2, USING "   ##  ##.## ##.## ##.######"; K; ZB(L); ZH(L); ZI(L);
     NEXT K
     PRINT #2, : PRINT #2,
   NEXT I
   '
   PRINT #2, : PRINT #2, : PRINT #2,
   IF Unit = SisTec THEN
      PRINT #2, "    Modulo di elasticita` = "; EL; " kg/cm2"
   ELSE
      PRINT #2, "    Modulo di elasticita` = "; EL; " N/mm2 "
   END IF
   '
RETURN

DistinguiTelai:
   DIM Npil(20)
   Ntel = 1
   UltPil = 0
   FOR I = 1 TO IZ - 1
      Pend = 0
      FOR K = 1 TO KZ
         L = NT(I, K)
         IF ZI(L) <> 0 THEN Pend = 1
      NEXT K
      IF Pend = 0 THEN
         Npil(Ntel) = I
         Ntel = Ntel + 1
         UltPil = I
      END IF
   NEXT I
   Npil(Ntel) = IZ
RETURN

' ----- calcola l'indice di rigidezza delle aste
'       effettua la loro somma nei nodi e nel piano
3000
   FOR K = 1 TO KZ
      FOR I = 1 TO IZ - 1
         L = NT(I, K)
         WT(I, K) = E * ZI(L) / DL(I)
      NEXT I
      FOR I = 1 TO IZ
         L = NR(I, K)
         WR(I, K) = E * ZI(L) / H(I, K)
      NEXT I
   NEXT K
   '
   FOR K = 1 TO KZ
      FOR I = 1 TO IZ
         S = WR(I, K)
         IF I > 1 THEN S = S + WT(I - 1, K)
         IF I < IZ THEN S = S + WT(I, K)
         IF K < KZ THEN S = S + WR(I, K + 1)
         WN(I, K) = S
      NEXT I
   NEXT K
   '
   FOR K = 1 TO KZ
      GOSUB 3600 '         calcola somma delle rigidezze
      WX(K) = S
   NEXT K
   '
RETURN

' calcola somma delle rigidezze
3600
   S = 0
   FOR I = 1 TO IZ
      S = S + WR(I, K) / H(I, K) ^ 2
   NEXT I
RETURN

' ----- effettua l'input dei carichi verticali, nodali ed orizzontali
'       azzera i carichi che non legge
4000
   IF Contr THEN PRINT #2, "------------------------------------------------------------"
   IF NOT (IV = 0) THEN
      FOR K = KZ TO 1 STEP -1
         IF Contr THEN PRINT #2, "carichi verticali sulle travi del traverso"; K; ":"
         FOR I = 1 TO IZ - 1
            INPUT #1, Q(I, K)
            IF Contr THEN PRINT #2, Q(I, K);
         NEXT I
         IF Contr THEN PRINT #2,
      NEXT K
   ELSE
      '  azzera carichi verticali
      FOR K = 1 TO KZ
         FOR I = 1 TO IZ
            Q(I, K) = 0
         NEXT I
      NEXT K
   END IF
   '
   IF NOT (IM = 0) THEN
      FOR K = KZ TO 1 STEP -1
         IF Contr THEN PRINT #2, "momenti concentrati nei nodi del traverso"; K; ":"
         FOR I = 1 TO IZ
            INPUT #1, MN(I, K)
            IF Contr THEN PRINT #2, MN(I, K);
         NEXT I
         IF Contr THEN PRINT #2,
      NEXT K
   ELSE
      '  azzera momenti nodali
      FOR K = 1 TO KZ
         FOR I = 1 TO IZ
            MN(I, K) = 0
         NEXT I
      NEXT K
   END IF
   '
   IF NOT (IO = 0) THEN
      IF Contr THEN PRINT #2, "forze orizzontali:"
      FOR K = KZ TO 1 STEP -1
         INPUT #1, FX(K)
         IF Contr THEN PRINT #2, FX(K);
      NEXT K
      IF Contr THEN PRINT #2,
   ELSE
      '  azzera carichi orizzontali
      FOR K = 1 TO KZ
         FX(K) = 0
      NEXT K
   END IF
   '
   IF Contr THEN PRINT #2, "------------------------------------------------------------"
RETURN

' ------ stampa i valori del carico verticale, nodale, orizzontale
5000
   PRINT #2, : PRINT #2, : PRINT #2, : PRINT #2, : PRINT #2,
   PRINT #2, "    CARICHI"
   IF KZ > 4 THEN KV = 4 ELSE KV = KZ
   IF IV <> 0 THEN
      '     carichi verticali
      IF Unit = SisTec THEN
         A$ = "          (t/m) ": B$ = "    ##  ####.## "
      ELSE
         A$ = "         (kN/m) ": B$ = "    ##  #####.# "
      END IF
      PRINT #2, : PRINT #2, : PRINT #2,
      PRINT #2, "    CARICHI VERTICALI": PRINT #2,
      PRINT #2, "     campata";
      FOR K = 1 TO KV
         PRINT #2, "   piano  carico";
      NEXT K
      PRINT #2,
      PRINT #2, "            ";
      FOR K = 1 TO KV
         PRINT #2, A$;
      NEXT K
      PRINT #2, : PRINT #2,
      FOR I = 1 TO IZ - 1
         PRINT #2, USING "    ### -###"; NP(I); NP(I + 1);
         FOR K = KZ TO 1 STEP -1
            IF (KZ - K) MOD 4 = 0 AND K < KZ THEN PRINT #2, : PRINT #2, "            ";
            PRINT #2, USING B$; K; Q(I, K);
        NEXT K
        PRINT #2, : PRINT #2,
      NEXT I
   END IF
   '
   IF IM <> 0 THEN
      '     carichi nodali
      IF Unit = SisTec THEN
         A$ = "          (tm)  ": B$ = "    ##  ####.## "
      ELSE
         A$ = "         (kNm)  ": B$ = "    ##  #####.# "
      END IF
      PRINT #2, : PRINT #2, : PRINT #2,
      PRINT #2, "    MOMENTI NEI NODI ": PRINT #2,
      PRINT #2, "    pilastro";
      FOR K = 1 TO KV
         PRINT #2, "   piano momento";
      NEXT K
      PRINT #2,
      PRINT #2, "            ";
      FOR K = 1 TO KV
         PRINT #2, A$;
      NEXT K
      PRINT #2, : PRINT #2,
      FOR I = 1 TO IZ
         PRINT #2, USING "      ###   "; NP(I);
         FOR K = KZ TO 1 STEP -1
            IF (KZ - K) MOD 4 = 0 AND K < KZ THEN PRINT #2, : PRINT #2, "            ";
            PRINT #2, USING B$; K; MN(I, K);
        NEXT K
        PRINT #2, : PRINT #2,
      NEXT I
   END IF
   '
   IF IO <> 0 THEN
      '     carichi orizzontali
      IF Unit = SisTec THEN
         A$ = "               (t)": B$ = "     ##     ####.##"
      ELSE
         A$ = "              (kN)": B$ = "     ##     #####.#"
      END IF
      PRINT #2, : PRINT #2, : PRINT #2,
      PRINT #2, "    FORZE ORIZZONTALI": PRINT #2,
      PRINT #2, "    piano     forza"
      PRINT #2, A$: PRINT #2,
      FOR K = KZ TO 1 STEP -1
         PRINT #2, USING B$; K; FX(K)
      NEXT K
   END IF
   '
RETURN

' ----- calcola somma momenti d'incastro perfetto e momenti nei nodi
'       calcola somma forze
6000
   FOR K = 1 TO KZ
      SM(1, K) = MN(1, K)
      FOR I = 1 TO IZ - 1
         V = Q(I, K) * DL(I) ^ 2 / 12
         SM(I, K) = SM(I, K) + V
         SM(I + 1, K) = MN(I + 1, K) - V
      NEXT I
   NEXT K
   '
   FOR K = 1 TO KZ
      QX(K) = FX(K)
   NEXT K
   FOR K = KZ - 1 TO 1 STEP -1
      K1 = K + 1
      QX(K) = QX(K) + QX(K1)
   NEXT K
   '
RETURN

' ----- effettua la risoluzione iterativa del sistema
7000
   GOSUB 7200 '           azzera rotazioni e spostamenti
   DO
      SQ = 0
      FOR K = 1 TO KZ
         FOR I = 1 TO IZ
            GOSUB 7400 '     operazione di nodo
         NEXT I
         GOSUB 7600 '        operazione di piano
      NEXT K
   LOOP UNTIL SQ = 0
RETURN

' azzera rotazioni e spostamenti
7200
   FOR K = 1 TO KZ
      FOR I = 1 TO IZ
         Fi(I, K) = 0
      NEXT I
      D(K) = 0
   NEXT K
RETURN

' operazione di nodo per il nodo I,K
7400
   IF WN(I, K) = 0 THEN RETURN
   S = SM(I, K) + 6 * WR(I, K) * D(K) / H(I, K)
   IF K > 1 THEN S = S - 2 * WR(I, K) * Fi(I, K - 1)
   IF K < KZ THEN S = S + 6 * WR(I, K + 1) * D(K + 1) / H(I, K + 1) - 2 * WR(I, K + 1) * Fi(I, K + 1)
   IF I > 1 THEN S = S - 2 * WT(I - 1, K) * Fi(I - 1, K)
   IF I < IZ THEN S = S - 2 * WT(I, K) * Fi(I + 1, K)
   IF ABS(S - 4 * WN(I, K) * Fi(I, K)) < SqAm THEN RETURN
   Fi(I, K) = S / 4 / WN(I, K)
   SQ = 1
RETURN

' operazione di piano per il piano K
7600
   GOSUB 7800 '       somma
   S1 = QX(K) + 6 * S1
   IF ABS(S1 - 12 * WX(K) * D(K)) > SqAm THEN D(K) = S1 / 12 / WX(K): SQ = 1
RETURN

' somma
7800
   S1 = 0
   FOR I = 1 TO IZ
      V = Fi(I, K)
      IF K > 1 THEN V = V + Fi(I, K - 1)
      S1 = S1 + V * WR(I, K) / H(I, K)
   NEXT I
RETURN

' ----- calcola momento flettente, taglio, sforzo normale, spostamenti
'       utilizza le convenzioni di segno della Scienza delle Costruzioni
8000
   FOR K = 1 TO KZ
      FOR I = 1 TO IZ - 1
         V = Q(I, K) * DL(I) ^ 2 / 12
         MS(I, K) = (4 * Fi(I, K) + 2 * Fi(I + 1, K)) * WT(I, K) - V
         MD(I, K) = -((2 * Fi(I, K) + 4 * Fi(I + 1, K)) * WT(I, K) + V)
      NEXT I
      FOR I = 1 TO IZ
         IF K > 1 THEN V = Fi(I, K - 1) ELSE V = 0
         MT(I, K) = -((4 * Fi(I, K) + 2 * V - 6 * D(K) / H(I, K)) * WR(I, K))
         MP(I, K) = (2 * Fi(I, K) + 4 * V - 6 * D(K) / H(I, K)) * WR(I, K)
      NEXT I
   NEXT K
   FOR K = 1 TO KZ
      FOR I = 1 TO IZ - 1
         V = Q(I, K) * DL(I) / 2
         TS(I, K) = V + (MD(I, K) - MS(I, K)) / DL(I)
         TD(I, K) = -V + (MD(I, K) - MS(I, K)) / DL(I)
      NEXT I
      FOR I = 1 TO IZ
         TR(I, K) = (MT(I, K) - MP(I, K)) / H(I, K)
      NEXT I
   NEXT K
   FOR K = KZ TO 1 STEP -1
      FOR I = 1 TO IZ
         V = 0
         IF I > 1 THEN V = V + TD(I - 1, K)
         IF I < IZ THEN V = V - TS(I, K)
         IF K < KZ THEN V = V + SN(I, K + 1)
         SN(I, K) = V
      NEXT I
   NEXT K
   FOR K = 2 TO KZ
      D(K) = D(K) + D(K - 1)
   NEXT K
RETURN

' ----- stampa i risultati
9000
   PRINT #2, : PRINT #2, : PRINT #2, : PRINT #2, : PRINT #2,
   PRINT #2, "    RISULTATI"
   PRINT #2, : PRINT #2, : PRINT #2,
   PRINT #2, "    SPOSTAMENTO DEGLI IMPALCATI": PRINT #2,
   PRINT #2, "    impalcato      spostamento"
   PRINT #2, "                       (mm)"
   PRINT #2,
   FOR K = KZ TO 1 STEP -1
      PRINT #2, USING "       ##          ####.###"; K; D(K) * 1000
   NEXT K
   IF Unit = SisTec THEN
      A$ = "                     sinistra (tm) destra (tm) sinistra (t)  destra (t)"
      B$ = "   ######.## "
      C$ = "                      sup.  (tm)   inf.  (tm)       (t)    normale (t)"
   ELSE
      A$ = "                     sinistra(kNm) destra(kNm) sinistra(kN)  destra(kN)"
      B$ = "   #######.# "
      C$ = "                      sup. (kNm)   inf. (kNm)      (kN)    normale(kN)"
   END IF
   PRINT #2, : PRINT #2, : PRINT #2,
   PRINT #2, "    CARATTERISTICHE DI SOLLECITAZIONE NELLE TRAVI": PRINT #2,
   PRINT #2, "     campata  piano    momento a    momento a    taglio a     taglio a"
   PRINT #2, A$
   FOR I = 1 TO IZ - 1
      PRINT #2,
      FOR K = KZ TO 1 STEP -1
         PRINT #2, USING "    ### -###   ##"; NP(I); NP(I + 1); K;
         PRINT #2, USING B$; MS(I, K); MD(I, K); TS(I, K); TD(I, K)
      NEXT K
   NEXT I
   PRINT #2, : PRINT #2, : PRINT #2,
   PRINT #2, "    CARATTERISTICHE DI SOLLECITAZIONE NEI PILASTRI": PRINT #2,
   PRINT #2, "     pilastro piano    momento      momento       taglio      sforzo"
   PRINT #2, C$
   FOR I = 1 TO IZ
      PRINT #2,
      FOR K = KZ TO 1 STEP -1
         PRINT #2, USING "       ###     ##"; NP(I); K;
         PRINT #2, USING B$; MT(I, K); MP(I, K); TR(I, K); SN(I, K)
      NEXT K
   NEXT I
   PRINT #2, : PRINT #2, : PRINT #2,
RETURN

Rigidezze:
   DIM Taglio(Ntel, KZ), Spost(KZ)
   FOR K = 1 TO KZ
      PriPil = 1
      FOR T = 1 TO Ntel
         Taglio(T, K) = 0
         FOR I = PriPil TO Npil(T)
            Taglio(T, K) = Taglio(T, K) + TR(I, K)
         NEXT I
         PriPil = Npil(T) + 1
      NEXT T
   NEXT K
   Spost(1) = D(1)
   FOR K = 2 TO KZ
      Spost(K) = D(K) - D(K - 1)
   NEXT K
   PRINT #2, "    RIGIDEZZE DEI TELAI:"
   PRINT #2,
   IF Unit = SisTec THEN
      PRINT #2, "    telaio  piano       Taglio (t)     Spost.rel. (mm)     Rigidezza (t/mm)"
   ELSE
      PRINT #2, "    telaio  piano       Taglio (kN)    Spost.rel. (mm)     Rigidezza (kN/mm)"
   END IF
   PRINT #2,
   IF Unit = SisTec THEN
      A$ = "      ##     ##        ######.##          "
      B$ = "             ##        ######.##          "
      C$ = "###.###             ####.###"
   ELSE
      A$ = "      ##     ##        #######.#          "
      B$ = "             ##        #######.#          "
      C$ = "###.###             #####.##"
   END IF
   FOR T = 1 TO Ntel
      FOR K = KZ TO 1 STEP -1
         Rigid = Taglio(T, K) / Spost(K) / 1000
         IF K = KZ THEN
            PRINT #2, USING A$; T; K; Taglio(T, K);
         ELSE
            PRINT #2, USING B$; K; Taglio(T, K);
         END IF
         PRINT #2, USING C$; Spost(K) * 1000; Rigid
      NEXT K
      PRINT #2,
   NEXT T
   PRINT #2, : PRINT #2,
RETURN

